Unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ClipBrd, printers, Menus, ComCtrls, Buttons, Jpeg;

type
  TForm1 = class(TForm)
    MainMenu: TMainMenu;
    Print1: TMenuItem;
    PrintImage: TMenuItem;
    SelectPrinter1: TMenuItem;
    ClipBoard1: TMenuItem;
    Copy1: TMenuItem;
    Save1: TMenuItem;
    Hide1: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    Image1: TImage;
    PreView: TBitBtn;
    Image2: TImage;
    ScrollBarVer: TScrollBar;
    ScrollBarHor: TScrollBar;
    TrackBarTop: TTrackBar;
    TrackBarBot: TTrackBar;
    TrackBarLeft: TTrackBar;
    TrackBarRight: TTrackBar;
    Timer1: TTimer;
    BMP1: TMenuItem;
    JPG1: TMenuItem;
    SaveDialog: TSaveDialog;
    Panel1: TPanel;
    RadioGroup: TRadioGroup;
    Edit1: TEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label1: TLabel;
    PrinterSetup: TPrinterSetupDialog;
    Label2: TLabel;
    Printnoscale1: TMenuItem;
    btnentireimage: TButton;
    CheckBox1: TCheckBox;
    Printcustomzoom1: TMenuItem;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Bevel3: TBevel;
    Button1: TButton;
    Button2: TButton;
    CenterImageChk: TCheckBox;
    Open1: TMenuItem;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure PrintScaleImageClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PreViewClick(Sender: TObject);
    procedure ScrollBarVerChange(Sender: TObject);
    procedure TrackBarTopChange(Sender: TObject);
    procedure TrackBarBotChange(Sender: TObject);
    procedure TrackBarLeftChange(Sender: TObject);
    procedure TrackBarRightChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BMP1Click(Sender: TObject);
    procedure JPG1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroupClick(Sender: TObject);
    procedure SelectPrinter1Click(Sender: TObject);
    procedure btnentireimageClick(Sender: TObject);
    procedure Printnoscale1Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Printcustomzoom1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawMarquee(mStart, mStop : TPoint);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CenterImageChkClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure TrackBarLeftEnter(Sender: TObject);
    procedure TrackBarTopEnter(Sender: TObject);
    procedure TrackBarBotEnter(Sender: TObject);
    procedure TrackBarRightEnter(Sender: TObject);
    procedure GetEntireDesktopImage;
    Procedure GetActiveDesktopImage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
   Procedure WMHotkey( Var msg: TWMHotkey ); message WM_HOTKEY;
   Procedure WMEndSession(var Msg : TWMEndSession); message WM_ENDSESSION;
    { Private declarations }
  public
  end;

var
  Form1: TForm1;

implementation

uses Unit3;

{$R *.DFM}
type zooming=(asis,proportional,custom);
var   x1,y1,xfinal,yfinal : integer;
      t1 : tbitmap;
      ih,iw : integer;
      MinLeftMargin,MinTopMargin : single;
      ActiveWinRect : Trect;
      bmarquee : boolean;
      ptorigin,ptmove : tpoint;
      xdpi,ydpi : integer;
      xx1,yy1,xx2,yy2 : integer;
const flag1: byte=0;

Procedure TForm1.WMEndSession (var Msg : TWMEndSession);
begin form1.OnClose:=nil; msg.EndSession:=true;
      application.Terminate
end;

procedure TForm1.WMHotkey( Var msg: TWMHotkey );
begin
    if form1.Visible then exit;
    If msg.hotkey = 1 then
    begin flag1:=1; GetEntireDesktopImage
    end
    else
    begin flag1:=2; GetActiveDesktopImage;
    end;
    PreViewClick(form1); timer1.Enabled:=true;
    form1.show
end;

procedure ShowPrintMargins;
var s,t : string[9];
begin
 with form1 do
 begin
    xdpi:=GetDeviceCaps(printer.Handle,LOGPIXELSX);
    ydpi:=GetDeviceCaps(printer.Handle,LOGPIXELSY);
    MinLeftMargin:=GetDeviceCaps(printer.Handle,PHYSICALOFFSETX)/xdpi;
    MinTopMargin:=GetDeviceCaps(printer.Handle,PHYSICALOFFSETY)/ydpi;
    label12.caption:='Printer Hor pixel density= '+inttostr(xdpi)+' DPI';
    label13.caption:='Printer Ver pixel density= '+inttostr(ydpi)+' DPI';
    str(MinLeftMargin:6:3,s); str(MinTopMargin:6:3,t);
    label9.Caption:='Printer min Left margin ='+s+'( in)';
    label10.Caption:='Printer min Top margin ='+t+'( in)';
    label11.Caption:=printer.Printers.strings[printer.printerindex];
 end
end;{showprintmargins}

procedure PrintBitmapEx(var t : Tbitmap; zoomtype : zooming );
var
  PixelsPerInchX,PixelsPerInchY,PrintWidth, PrintHeight,i,j,left,top: integer;
  m,n : single;
begin
    with form1 do
    if (label5.caption='0')or(label6.Caption='0') then
    begin showmessage('Image dimensions cant be 0 !');
          exit
    end;
    PixelsperinchX:=GetDeviceCaps(printer.Handle,LOGPIXELSX);
    PixelsperinchY:=GetDeviceCaps(printer.Handle,LOGPIXELSY);
    val(trim(form1.edit3.text),m,i);
    val(trim(form1.edit4.text),n,j);
    if (i<>0)or(j<>0) then
    begin showmessage('Values for print margins are invalid, Aborted');
          exit
    end;
    left:=round(m*pixelsperinchx); top:=round(n*pixelsperinchy);
   with form1 do
    case
     zoomtype of
      asis :
        begin printwidth:=t.width;
              printheight:=t.Height
        end;
      proportional:
        begin printwidth:=t.Width*printer.PageWidth div screen.Width;
              printheight:=t.Height*printer.PageHeight div screen.Height;
        end;
      custom:
        begin val(trim(form1.edit2.text),m,i);
              if i<>0 then
              begin showmessage('Invalid magnification number');
                    exit
              end;
              printwidth:=round(m*t.width); printheight:=round(m*t.height);
              if printwidth>printer.PageWidth then printwidth:=printer.PageWidth;
              if printheight>printer.PageHeight then printheight:=printer.PageHeight
        end
    end;{case}
   if left+printwidth>printer.PageWidth then left:=0;
   if top+printheight>printer.PageHeight then top:=0;
   printer.BeginDoc;
   printer.Canvas.CopyMode:=cmSrcCopy;
   printer.Canvas.StretchDraw(rect(left,top,left+printwidth,top+printheight),t);
   printer.EndDoc
end;{printbitmapEx}

procedure ShowImageDimensions;
begin with form1 do
 begin
 label5.caption:='Width='+inttostr(TrackBarBot.position-TrackBarTop.position+1);
 label6.caption:='Height='+inttostr(TrackBarRight.position-TrackBarLeft.position+1);
 end;
end;{showimagedimensions}

procedure TForm1.GetEntireDesktopImage;
 var c : Tcanvas;
     h : Thandle;
     t2: Tbitmap;
     p : tpoint;
begin with form1 do
 begin  C:=Tcanvas.create; t1:=tbitmap.create;
        t1.width:=screen.width; t1.height:=screen.height;
        h:=GetDesktopWindow;
        c.Handle:=GetDC(GetDesktopWindow);
        GetWindowOrgEx(GetDC(getfocus),p);
        T1.canvas.CopyRect(rect(0,0,t1.width,t1.Height),C,
        rect(0,0,screen.width,screen.height));
        t1.PixelFormat:=pf24bit;

        t2:=tbitmap.create; t2.Height:=200; t2.Width:=267;
        t2.Canvas.StretchDraw(rect(0,0,t2.width,t2.height),t1);
        image1.Picture.Assign(t2);
        x1:=image1.Width div 3; y1:=image1.Height div 3;
        xfinal:=x1*2;  yfinal:=y1*2;
        h:=GetForeGroundWindow;
        GetWindowRect(h,ActiveWinRect);
        if flag1=1 then
        begin
        TrackBarTop.Position:=1;             //screen.Width div 3;
        TrackBarBot.Position:=screen.width;  //2*screen.Width div 3;
        TrackBarLeft.Position:=1;            //screen.Height div 3;
        TrackBarRight.Position:=screen.height//2*screen.Height div 3;
        end else with ActiveWinRect do
        begin
        TrackBarTop.Position:=left;
        TrackBarBot.Position:=right;
        TrackBarLeft.Position:=Top;
        TrackBarRight.Position:=bottom
        end;
        t2.free;
        ReleaseDC(h,C.Handle);
        c.Free;
        RadioGroup.ItemIndex:=0;
        edit1.Text:=inttostr(TrackBarTop.position);
        ShowImageDimensions;
        form1.Edit3Exit(edit3); form1.Edit4Exit(edit4);
 end
end;{GetEntireDesktopImage}

Procedure TForm1.GetActiveDesktopImage;
begin
      GetEntireDesktopImage
end;{GetActiveDesktopImage}


procedure DrawImageBorder(var image : Timage);
 var i,j,m,n : integer;
begin
 i:=image.Left-1; j:=image.Top-1; m:=image.Width+2; n:=image.Height+2;
 with form1.canvas do
 begin pen.color:=clblack;
      Polyline([point(i,j),point(i+m,j),point(i+m,j+n),point(i,j+n),point(i,j)])
 end
end;{drawimageborder}

procedure RefreshImage;
begin
 with form1 do
 image1.Canvas.StretchDraw(rect(0,0,image1.width,image1.height),t1);
end;

procedure ShowPrinterRes;
begin
   form1.label4.Caption:='Print area size '+inttostr(printer.pagewidth)+
   'x'+inttostr(printer.PageHeight)+' pixels'
end;{showprinterres}

procedure TForm1.FormCreate(Sender: TObject);
begin
    if
    RegisterHotkey(Handle, 1,0{ MOD_ALT or MOD_CONTROL}, VK_SNAPSHOT)=false
    then
    begin showmessage('Unable to register PrintScreen key !');
          application.Terminate
    end;
    if
    RegisterHotkey(Handle, 2,MOD_ALT {or MOD_CONTROL}, VK_SNAPSHOT)=false
    then
    begin showmessage('Unable to register Alt+PrintScreen key !');
          application.Terminate
    end;

    ih:=image2.Height; iw:=image2.Width;
    with image2.canvas do
    begin brush.Color:=clyellow;
          FillRect(rect(0,0,image2.width,image2.height))
    end;
    TrackBarLeft.Max:=screen.height; TrackBarRight.Max:=screen.height;
    TrackBarTop.Max:=screen.Width; TrackBarBot.Max:=screen.Width;
    label2.caption:='Screen size '+inttostr(screen.width)+
    'x'+inttostr(screen.height)+' pixels';
    ShowPrinterRes; ShowPrintMargins;
    form1.Brush.Style:=bssolid
end;

procedure TForm1.Hide1Click(Sender: TObject);
begin
 form1.Visible:=false;
 timer1.Enabled:=false;
 t1.free
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close
end;

procedure TForm1.FormPaint(Sender: TObject);
var i,j,m,n : integer;
begin
 DrawImageBorder(image1);
 //because image2 dims changes we must use this method for it's border drawing
 i:=image2.Left-1; j:=image2.Top-1; m:=iw+2; n:=ih+2;
 with canvas do
 begin pen.color:=clblack;
      Polyline([point(i,j),point(i+m,j),point(i+m,j+n),point(i,j+n),point(i,j)])
 end;
end;

procedure TForm1.ScrollBarVerChange(Sender: TObject);
 var showrect,mainrect : Trect;
     x,y,mx,my,ax,ay,dx,dy : integer;
begin
  mx:=TrackBarBot.Position;
  my:=TrackBarRight.Position;
  ax:=TrackBarTop.Position;
  ay:=TrackBarLeft.Position;
  dx:=abs(mx-ax); dy:=abs(my-ay);
  if (dx=0)or(dy=0) then
  begin beep;
        exit
  end;
  if ax<mx then x:=ax else x:=mx;
  if ay<my then y:=ay else y:=my;
  showrect:=rect(0,0,image2.width,image2.height);
  mainrect:=
  rect(x+ScrollBarHor.position,y+ScrollBarVer.position,
       x+ScrollBarHor.position+image2.Width,y+ScrollBarVer.position+image2.Height);
  image2.Canvas.CopyRect(showrect,t1.Canvas,mainrect);
end;

procedure TForm1.PreViewClick(Sender: TObject);
//global var iw,ih are the original dimensions of image2
var i,j,w,h : integer;
begin
   i:=abs(TrackBarTop.position-TrackBarBot.position);
   w:=i;
   i:=i-iw;
   if i<0 then i:=0;
   ScrollBarHor.Max:=i;

   j:=abs(TrackBarLeft.position-TrackBarRight.position);
   h:=j;
   j:=j-ih;
   if j<0 then j:=0;
   ScrollBarVer.Max:=j;
   image2.canvas.FillRect(rect(0,0,iw,ih));
   if w<iw then image2.Width:=w else image2.Width:=iw;
   if h<ih then image2.Height:=h else image2.Height:=ih;

   ScrollBarHor.Position:=1;
   ScrollBarVer.Position:=1;
   ShowImageDimensions;
   ScrollBarVerChange(Sender);
end;

procedure TForm1.TrackBarTopChange(Sender: TObject);
begin
 //Radiogroup.ItemIndex:=0;
 RefreshImage;
 with TrackBarTop do
 if Position>TrackBarBot.Position then position:=TrackBarBot.Position;
 x1:=TrackBarTop.Position*image1.width div screen.width;
 edit1.Text:=inttostr(TrackBarTop.Position); ShowImageDimensions
end;

procedure TForm1.TrackBarBotChange(Sender: TObject);
begin
 //Radiogroup.ItemIndex:=1;
 RefreshImage;
 with TrackBarBot do
 if Position<TrackBarTop.Position then Position:=TrackBarTop.Position;
 xfinal:=TrackBarBot.Position*image1.width div screen.width;
 edit1.Text:=inttostr(TrackBarBot.Position); ShowImageDimensions
end;

procedure TForm1.TrackBarLeftChange(Sender: TObject);
begin RefreshImage;
 with TrackBarLeft do
 if Position>TrackBarRight.Position then position:=TrackBarRight.Position;
 //Radiogroup.ItemIndex:=2;
 y1:=TrackBarLeft.Position*image1.Height div screen.Height;
 edit1.Text:=inttostr(TrackBarLeft.Position);
 ShowImageDimensions
end;

procedure TForm1.TrackBarRightChange(Sender: TObject);
begin RefreshImage;
 with TrackBarRight do if
 Position<TrackBarLeft.Position then Position:=TrackBarLeft.Position;
 //Radiogroup.ItemIndex:=3;
 yfinal:=TrackBarRight.Position*image1.Height div screen.Height;
 edit1.Text:=inttostr(TrackBarRight.Position); ShowImageDimensions
end;

procedure TForm1.Timer1Timer(Sender: TObject);

begin
 xx1:=TrackBarTop.Position*image1.width div screen.Width;
 yy1:=TrackBarLeft.position*image1.height div screen.Height;
 xx2:=TrackBarBot.Position*image1.width div screen.Width;
 yy2:=TrackBarRight.Position*image1.height div screen.Height;
 with Image1.Canvas do
 begin
  pen.Mode:=pmxor;
  Pen.Color :=clwhite;
  Pen.Width :=1;
  Pen.Style :=psdot;
  Brush.Style :=bsClear;
  Rectangle(xx1,yy1,xx2,yy2)
 end
end;

procedure SaveBMPformat;
 var t : tbitmap;
begin t:=tbitmap.Create;
 with form1 do
 begin
   t.Height:=abs(TrackBarLeft.Position-TrackBarRight.Position);
   t.Width:=abs(TrackBarTop.position-TrackBarBot.Position);
   t.Canvas.CopyRect(rect(0,0,t.width,t.height),t1.canvas,
                 rect(TrackBarTop.position,TrackBarLeft.Position,
                 TrackBarBot.position,TrackBarRight.position));
 end;
 if (t.Height<>0)and(t.Width<>0) then t.SaveToFile(form1.savedialog.filename);
 t.Free
end;

procedure SaveJPGformat;
 var t : Tbitmap;
     jpeg : TJPEGImage;
begin
 with form1 do
 begin t:=Tbitmap.Create;
   t.Height:=abs(TrackBarLeft.Position-TrackBarRight.Position);
   t.Width:=abs(TrackBarTop.position-TrackBarBot.Position);
   t.Canvas.CopyRect(rect(0,0,t.width,t.height),t1.canvas,
                 rect(TrackBarTop.position,TrackBarLeft.Position,
                 TrackBarBot.position,TrackBarRight.position));
    jpeg:=Tjpegimage.Create;
    jpeg.Assign(t); jpeg.SaveToFile(savedialog.filename);
    jpeg.Free
 end
end;

procedure TForm1.BMP1Click(Sender: TObject);
begin
 savedialog.Filter:='BMP files | *.BMP';
 savedialog.DefaultExt:='BMP';
 with savedialog do
 if (Execute)and(trim(filename)<>'') then
 SaveBMPformat
end;

procedure TForm1.JPG1Click(Sender: TObject);
begin
 savedialog.Filter:='JPG files | *.JPG';
 savedialog.DefaultExt:='JPG';
 with savedialog do
 if Execute and (trim(filename)<>'') then SaveJPGformat
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
UnRegisterHotkey(Handle,1); UnRegisterHotkey(Handle,2);
t1.free
end;

procedure TForm1.Copy1Click(Sender: TObject);
var t : Tbitmap;
  R : Trect;
  x,y,h,w : integer;
begin
    x:=TrackBarTop.Position; y:=TrackBarLeft.Position;
    w:=abs(TrackBarTop.Position-TrackBarBot.Position);
    h:=abs(TrackBarLeft.Position-TrackBarRight.Position);
    R:=rect(x,y,x+w,y+h);
    t:=Tbitmap.Create; t.Width:=w; t.Height:=h;
    t.Canvas.CopyRect(rect(0,0,t.width,t.Height),t1.canvas,R);
    clipboard.Assign(t);
    t.Free
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key in['0'..'9',#8] then else key:=#0
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
   vk_F1 : PreViewClick(Sender);
  end
end;

procedure TForm1.RadioGroupClick(Sender: TObject);
begin
  if form1.Visible then
  case Radiogroup.ItemIndex of
   0: begin edit1.Text:=inttostr(TrackBarTop.Position);
            TrackBarTop.SetFocus
      end;
   1: begin edit1.Text:=inttostr(TrackBarBot.Position);
         TrackBarBot.SetFocus
      end;
   2: begin edit1.Text:=inttostr(TrackBarLeft.Position);
         TrackBarLeft.SetFocus
      end;
   3: begin edit1.Text:=inttostr(TrackBarRight.Position);
         TrackBarRight.SetFocus
      end
   end{case}
end;

procedure TForm1.SelectPrinter1Click(Sender: TObject);
begin PrinterSetup.Execute;
    if printer.Orientation=polandscape then checkbox1.Checked:=true else
    checkbox1.Checked:=false;
    ShowPrinterRes; ShowPrintMargins;
    label11.Caption:=printer.Printers.strings[printer.printerindex];
end;

procedure TForm1.btnentireimageClick(Sender: TObject);
begin
 TrackBarTop.Position:=1; TrackBarBot.Position:=screen.width;
 TrackBarLeft.Position:=1; TrackBarRight.Position:=screen.Width;
 x1:=1; xfinal:=TrackBarBot.Position*image1.width div screen.width;
 y1:=1; yfinal:=TrackBarRight.Position*image1.Height div screen.Height;
 RadioGroup.ItemIndex:=0; Edit1.Text:='1';
 PreViewClick(Sender);RefreshImage;
end;

procedure TForm1.PrintScaleImageClick(Sender: TObject);
 var t : tbitmap;
     x,y,m,n : integer;
begin x:=TrackbarTop.Position; y:=TrackBarLeft.Position;
      m:=TrackBarBot.Position; n:=TrackbarRight.Position;
      t:=tbitmap.Create; t.Width:=m-x; t.Height:=n-y;
      t.canvas.CopyRect(rect(0,0,t.width,t.height),t1.canvas,rect(x,y,m,n));
      PrintBitMapEx(t,proportional);
      t.free
end;

procedure TForm1.Printnoscale1Click(Sender: TObject);
 var t : tbitmap;
     w,h : integer;
begin
 w:=abs(TrackBarBot.Position-TrackBarTop.Position);
 h:=abs(TrackBarRight.Position-TrackBarLeft.Position);
 t:=tbitmap.create; t1.PixelFormat:=pf24bit;
 t.width:=w; t.height:=h;
 t.Canvas.CopyRect(rect(0,0,w,h),t1.canvas,
 rect(TrackBarTop.Position,TrackBarLeft.Position,TrackBarBot.Position,TrackBarRight.Position));
 PrintBitMapEx(t,asis);
 t.free
end;

procedure TForm1.PrintCustomZoom1Click(Sender: TObject);
 var t : tbitmap;
     x,y,m,n : integer;
begin x:=TrackbarTop.Position; y:=TrackBarLeft.Position;
      m:=TrackBarBot.Position; n:=TrackbarRight.Position;
      t:=tbitmap.Create; t.Width:=m-x; t.Height:=n-y;
      t.canvas.CopyRect(rect(0,0,t.width,t.height),t1.canvas,rect(x,y,m,n));
      PrintBitMapEx(t,custom);
      t.free
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
 if key=#8 then exit;
 if (key='.')and(pos('.',Tedit(sender).text)<>0) then
 begin key:=#0;
       exit
 end;
 if key in['0'..'9','.'] then else key:=#0
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if checkbox1.Checked then printer.Orientation:=polandscape
 else printer.Orientation:=poPortrait;
 ShowPrinterRes; ShowPrintMargins
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 showmessage('FREEWARE PrintScreen program for Windows'+#13+
             'By Omid Motahed')
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
form3.Show
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
 if (trim(edit2.text)='')or(strtofloat(edit2.text)=0)
 then edit2.Text:='1.0'
end;

procedure TForm1.Edit3Exit(Sender: TObject);
var s : string[9];
begin
 if (trim(edit3.Text)='')or(strtofloat(edit3.text)<MinLeftMargin) then
 begin str(MinLeftMargin:4:2,s);
       edit3.Text:=s
 end
end;

procedure TForm1.Edit4Exit(Sender: TObject);
var s : string[9];
begin
 if (trim(edit4.Text)='')or(strtofloat(edit4.text)<MinTopMargin) then
 begin str(MinTopMargin:4:2,s);
       edit4.Text:=s
 end
end;

procedure TForm1.DrawMarquee(mStart, mStop : TPoint);
begin
 with Image1.Canvas do
 begin
  Pen.Mode :=pmXor;
  Pen.Color :=clwhite;
  Pen.Width :=1;  
  Pen.Style :=psdot;
  Brush.Style :=bsClear;
  Rectangle(mStart.X,mStart.Y,mStop.X,mStop.Y)
 end
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin Timer1.Enabled:=false;
  bMarquee := True;
  ptOrigin := Point(X,Y);
  ptMove  := Point(X,Y);
  RefreshImage
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if bMarquee = True then
 begin
  DrawMarquee(ptOrigin, ptMove);
  DrawMarquee(ptOrigin, Point(X,Y));
  ptMove := Point(X, Y);
  //image1.Canvas.Pen.Mode :=pmblack{ pmCopy};
 end
end;
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var x1,y1,x2,y2 : integer;
  label done;
begin
 if bMarquee then
 begin
  bMarquee := False;
  DrawMarquee(ptOrigin, Point(X,Y)); Timer1.Enabled:=true;
  if (abs(ptorigin.x-x)<2)or(abs(ptorigin.y-y)<2) then goto done;
  ptMove := Point(X,Y);
  if  ptmove.x>ptorigin.x then
  begin x1:=ptorigin.x; y1:=ptorigin.y;
        x2:=ptmove.x; y2:=ptmove.y
  end else
  begin x2:=ptorigin.x; y2:=ptorigin.y;
        x1:=ptmove.x; y1:=ptmove.y
  end;
  x1:=x1*screen.Width div image1.Width ;
  x2:=x2*screen.Width div image1.Width;
  y1:=y1*screen.Height div image1.Height;
  y2:=y2*screen.Height div image1.Height;
  TrackBarTop.Position:=x1; TrackBarLeft.Position:=y1;
  TrackBarBot.Position:=x2; TrackBarRight.Position:=y2;
  case radiogroup.ItemIndex of
   0: edit1.text:=inttostr(x1);
   1: edit1.text:=inttostr(x2);
   2: edit1.text:=inttostr(y1);
   3: edit1.text:=inttostr(y2)
   end;
  done:
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 with ActiveWinRect do
 begin TrackBarTop.position:=Left;
       TrackBarLeft.position:=Top;
       TrackBarBot.Position:=Right;
       TrackBarRight.Position:=Bottom;
 end;RefreshImage;
 ShowImageDimensions;
 Radiogroup.ItemIndex:=0;
 edit1.Text:=inttostr(TrackBarTop.position)
end;

procedure TForm1.Button2Click(Sender: TObject);
 procedure Error;
 begin showmessage('Invalid numerical range')
 end;{error}
var s :string[10]; i : integer;
begin s:=trim(edit1.text); if s='' then exit;
   i:=strtoint(s);
   if i=0 then begin error ;exit end;
   case RadioGroup.ItemIndex of
   0: if i+1<TrackBarBot.Position then TrackBarTop.Position:=i else
      begin Error;
            edit1.text:=inttostr(TrackBarTop.Position)
      end;
   1: if (i>screen.Width)or(i<TrackBarTop.Position+1) then
      begin Error;
            edit1.text:=inttostr(TrackBarBot.Position);
      end
      else TrackBarBot.Position:=i;
   2: if i+1<TrackBarRight.Position then TrackBarLeft.Position:=i else
      begin Error;
            edit1.Text:=inttostr(TrackBarLeft.Position)
      end;
   3: if (i>screen.Height)or(i<TrackBarLeft.Position+1) then
      begin Error;
            edit1.Text:=inttostr(TrackBarRight.Position)
      end
      else
      TrackBarRight.Position:=i
   end;{case}
end;

procedure TForm1.CenterImageChkClick(Sender: TObject);
begin
 if CenterImageChk.Checked then
 begin edit3.Enabled:=false;
       edit4.Enabled:=false;
 end else
 begin edit3.Enabled:=true;
       edit4.Enabled:=true;
 end
end;


procedure TForm1.Open1Click(Sender: TObject);
 var s : shortstring; i : integer;
     a: Tbitmap; b: TJpegimage;

 procedure Common;
 begin ActiveWinRect.Left:=1;ActiveWinRect.Top:=1;
    TrackBarTop.Position:=1; TrackBarLeft.Position:=1;
    t1.Canvas.Brush.Color:=clwhite;
    t1.Canvas.FillRect(rect(0,0,t1.width,t1.height));
 end;{common}

begin
 if Opendialog.Execute then
 begin
  s:=opendialog.filename; s:=trim(s); if trim(s)='' then exit;
  s:=uppercase(s); i:=length(s);
  if pos('.BMP',s)=i-3 then
  begin Common;
    a:=tbitmap.create; a.LoadFromFile(s); a.PixelFormat:=pf24bit;
    t1.Canvas.CopyRect(rect(0,0,a.width,a.height),a.canvas,rect(0,0,a.width,a.height));
    ActiveWinRect.Bottom:=a.Height; ActiveWinRect.Right:=a.width;
    TrackBarRight.Position:=a.Height; TrackBarBot.Position:=a.Width; a.free;
    image1.Picture.Bitmap.Canvas.StretchDraw(rect(0,0,image1.width,image1.height),t1);
    PreViewClick(Sender);
  end
  else if (pos('.JPG',s)=i-3)or(pos('.JPEG',s)=i-4) then
  begin Common; a:=Tbitmap.create;
    b:=Tjpegimage.create; b.LoadFromFile(s); a.Assign(b);
    t1.Canvas.CopyRect(rect(0,0,b.width,b.height),a.canvas,rect(0,0,b.width,b.height));
    TrackBarRight.Position:=b.height; TrackBarBot.Position:=b.Width;
    image1.Picture.Bitmap.Canvas.StretchDraw(rect(0,0,image1.width,image1.height),t1);
    a.free; b.Free;
    PreViewClick(Sender);
  end
 end
end;

procedure TForm1.TrackBarLeftEnter(Sender: TObject);
begin
 radiogroup.ItemIndex:=2;
 edit1.text:=inttostr(TrackBarLeft.position)
end;

procedure TForm1.TrackBarTopEnter(Sender: TObject);
begin
 radiogroup.ItemIndex:=0;
 edit1.text:=inttostr(TrackBartop.position)
end;

procedure TForm1.TrackBarBotEnter(Sender: TObject);
begin
 radiogroup.ItemIndex:=1;
 edit1.text:=inttostr(TrackBarBot.position)
end;

procedure TForm1.TrackBarRightEnter(Sender: TObject);
begin
 radiogroup.ItemIndex:=3;
 edit1.text:=inttostr(TrackBarRight.position)
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 case messagedlg('Are you sure ?',
      mtconfirmation,[mbyes,mbno],0) of
      mryes :  action:=cafree;
      mrno : action:=canone
  end

end;

end.
