unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Registry;

type
  TForm3 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Print1: TMenuItem;
    EnableAutoRun1: TMenuItem;
    Exit1: TMenuItem;
    ViaLPT11: TMenuItem;
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure EnableAutoRun1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ViaLPT11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

procedure TForm3.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
 if key<>#3 then key:=#0
end;

procedure SetAutoStart(AppName, AppTitle: string; register: boolean);
const
   RegKey = '\Software\Microsoft\Windows\CurrentVersion\Run';
   // or: RegKey = '\Software\Microsoft\Windows\CurrentVersion\RunOnce';
var
  Registry: TRegistry;
begin
  Registry := TRegistry.Create;
  Registry.RootKey := HKEY_LOCAL_MACHINE;
    if Registry.OpenKey(RegKey, False) then
    begin
      if register = false then
        Registry.DeleteValue(AppTitle)
      else
       begin
         Registry.WriteString(AppTitle, AppName);
         showmessage('Program was registered successfully')
       end  
    end;
    Registry.Free;
end;

procedure TForm3.EnableAutoRun1Click(Sender: TObject);
begin
    SetAutoStart(paramstr(0),'Freeware Printscreen utility by Omid Motahed',true)
//
end;

procedure TForm3.Exit1Click(Sender: TObject);
begin
 close
end;

procedure TForm3.ViaLPT11Click(Sender: TObject);
var s : tstringlist;
begin
 s:=tstringlist.Create; s.Assign(memo1.lines); s.Add(#12);
 s.SaveToFile('LPT1'); s.Free
end;

end.
